1. 程式人生 > >POJ3126 Prime Path【BFS】

POJ3126 Prime Path【BFS】

Prime Path

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 28470 Accepted: 15534

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.  — It is a matter of security to change such things every now and then, to keep the enemy in the dark.  — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!  — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.  — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!  — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.  — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.  Now, the minister of finance, who had been eavesdropping, intervened.  — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.  — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?  — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033 1733 3733 3739 3779 8779 8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

問題描述:給定兩個四位素數a  b,要求把a變換到b。變換的過程要保證每次變換出來的數都是一個 四位素數,而且當前這步的變換所得的素數 與 前一步得到的素數只能有一個位不同,而且每步得到的素數都不能重複。求從a到b最少需要的變換次數。無法變換則輸出Impossible

解題思路:先打表計算四位數的素數,每次改變當前數的某一位,BFS,細節看程式碼

AC的C++程式碼:

#include<iostream>
#include<string>
#include<cstring>
#include<queue>

using namespace std;

const int N=10005;
bool prime[N+1];
bool vis[N];

void maketable(int n)
{
	prime[0]=prime[1]=true;
	for(int i=2;i<=n;i++)
	  if(!prime[i]){
	  	for(int j=i+i;j<=n;j+=i)
	  	  prime[j]=true;
	  }
}

struct Node{
	string v;
	int step;
	Node(){}
	Node(string v,int step):v(v),step(step){}
};

int getval(string s)
{
	int ans=0;
	for(int i=0;i<s.length();i++)
	  ans=ans*10+s[i]-'0';
	return ans;
}

int bfs(string s,string en)
{
	memset(vis,false,sizeof(vis));
	int v=getval(s);
	vis[v]=true;
	queue<Node>q;
	q.push(Node(s,0));
	while(!q.empty()){
		Node f=q.front();
		if(en==f.v)
		  return f.step;
		q.pop();
		for(int i=0;i<4;i++){
			int st=(i==0)?1:0;
			for(int j=st;j<=9;j++){
				string str=f.v;
				str[i]=j+'0';
				int val=getval(str);
				if(!vis[val]&&!prime[val]){//如果這個數是素數且沒被訪問 
					vis[val]=true;//標記這個數被訪問了 
					q.push(Node(str,f.step+1));
				}
			}
		}
	}
	return -1;//不存在就返回-1 
}

int main()
{
	int t;
	string s,en;
	cin>>t;
	maketable(N);
	while(t--){
		cin>>s>>en;
		int ans=bfs(s,en);
		if(ans==-1)
		  cout<<"Impossible"<<endl;
		else
		  cout<<ans<<endl;
	}
	return 0;
}